import numpy as np

# Los vectores para guardar
# la red

eta = 0.5

np.random.seed( 3 )

vz = np.zeros( 3 )
va = np.zeros( 3 )
vw = np.random.rand( 9 )
vdelta = np.zeros( 3 )
vder = np.zeros( 9 )

def s( x ) :
	return 1/(1 + np.exp( -x ))

def hacia_adelante( x1, x2 ) :
	# Calculamos zi, ai y el error
	vz[0] = x1*vw[0] + x2*vw[3] + vw[2]
	vz[1] = x1*vw[1] + x2*vw[4] + vw[5]

	va[0] = np.tanh( vz[0] )
	va[1] = np.tanh( vz[1] )

	vz[2] = va[0]*vw[6] + va[1]*vw[7] + vw[8]
	va[2] = s( vz[2] )


def hacia_atras(  t ) :
	# Calculamos delta i 
	vdelta[2] = s( vz[2] ) * ( 1 - s( vz[2] ) )*(va[2] - t)
	vdelta[1] = ( 1.0/np.cosh( vz[1] )) * vdelta[2]*vw[7]
	vdelta[0] = ( 1.0/np.cosh( vz[0] ))*vdelta[2]*vw[6]

def DG( x1, x2 ) :
	# El descenso de gradiente
	vw[0] = vw[0] - eta * x1 * vdelta[0]
	vw[1] = vw[1] - eta * x1 * vdelta[1]
	vw[2] = vw[2] - eta * vdelta[1]

	vw[3] = vw[3] - eta * x2 * vdelta[0]
	vw[4] = vw[4] - eta * x2 * vdelta[1]
	vw[5] = vw[5] - eta * vdelta[1]

	vw[6] = vw[6] - eta * va[0] * vdelta[2]
	vw[7] = vw[7] - eta * va[1] * vdelta[2]
	vw[8] = vw[8] - eta * vdelta[2]


# Leer el archivo de archivo de entrada

D = np.loadtxt( "datos.txt" )

n, m = D.shape

# Número de épocas
epocas = 200
# Tamaño del batch
m = 4

# Para todas la épocas
i = 0
while i<epocas :  
	# tamaño del batch
	j = 0
	while j<n :
		k = 0
		while k < m :
			l = j+k
			hacia_adelante( D[l,0], D[l,1] )
			hacia_atras( D[l,2] )
			DG( D[l,0], D[l,1] )
			k += 1

		j += m 

	# Error en la época
	error = 0
	k = 0
	while k < n :
		hacia_adelante( D[k,0], D[k,1] )
		e = va[2] - D[k,2]
		error += e*e 
		k += 1
	error /= 2.0
	print( i,  error )

	i += 1

print( vw )


